Doomsday Engine - Feature #7

Next-gen renderer (codename "Gloom™")
2013-10-11 09:46 - skyjake

Status: Progressed Start date: 2003-07-10
Priority: Urgent % Done: 30%
Assignee: skyjake

Category: Redesign

Target version: 3.0

Description

Doomsday's renderer in version 1.9 was fully based on OpenGL 1.4. There was no support for shaders, for instance.

All the graphics code should be revised to use the libgui GL classes instead, which are OpenGL 3.3 (OpenGL ES 2) compatible. In
practice, this means comprehensive changes to the entire stack of drawing routines:

® OpenGL state should be managed exclusively using GLState
¢ Textures and other image content should be grouped in AtlasTextures
¢ Vertex data should be stored in VBOs and kept around as static data as long as possible (across multiple frames)

Once the entire renderer is using libgui, we can start revising certain portions like how materials are drawn (should use shaders
instead of hard-coded effects).

Subtasks:

Feature # 6: Draw lens flares using GL2 Progressed
Feature # 1362: Smoothing of dynlights & halos New
Feature # 1662: Refactor camera lens effects Closed

Feature # 8: New GL2 based model renderer Closed

Feature # 1623: Shaders Progressed

Feature # 1624: Render particles to textures Rejected

Feature # 1625: Per-pixel surface shading (bump/specular/reflection etc. mapping) Progressed

Feature # 1626: Area-based fog New

Feature # 1627: Render game view to a texture Closed

Feature # 1628: Surface meshes New

Feature # 1635: HDR rendering Resolved

Feature # 1370: Halos with fading trails (to go with the slowed occlusion) Rejected

Feature # 1699: Particle renderer 2.0 New

Feature # 1890: New sequence-based model animation mechanism Closed

Feature # 1900: OpenGL 3.3 Core Profile Closed

Feature # 1945: Efficient reuse of world geometry across multiple frames/passes Resolved

Feature # 2136: Add a map rendering abstraction layer for supporting both Classic and M... Rejected

Feature # 1233: Surface decorations using 3D models New

Feature # 2197: Remove the 'Bias' volumetric lighting system and the Bias light source ... Closed

Related issues:

Related to Feature #1201: Dynamic shadows New 2003-06-19
Related to Feature #1615: Sloped planes Progressed 2013-10-20
Related to Feature #1254: Portal based rendering Rejected 2003-08-01
Related to Feature #1388: 3D floors (Z-overlapped sectors) New 2005-09-19
Related to Feature #1313: Submodel rotation angles Rejected 2003-12-24
Related to Feature #1351: Dynamic Light polys rotated to match THING/Wall angle Rejected 2004-07-23
Related to Feature #1357: [InFine] More blending modes (add/mul/inv etc) New 2004-08-17
Related to Feature #1387: Use GL_POINT_SPRITE_ARB for tex particle rendering Rejected 2005-09-03
Related to Feature #1535: Option for fullbright textures affected by colored ... New 2011-05-05
Related to Feature #1564: Runtime option for enabling/disabling texture compr... Rejected 2012-06-24
Related to Bug #552: Ambient occlusion on middle surfaces of 2-sided lines New 2008-10-24
Related to Bug #882: Fullbright psprites and colored lighting
Related to Feature #1540: Smaller near clip distance

Related to Feature #1636: Support for Oculus Rift

Related to Bug #908: Detail texture maximum distance ignored
Related to Bug #606: Shiny texture coordinate issues

Related to Feature #1168: Real decals: bulletholes, blastmarks, etc.

Related to Feature #1647: Replace FS1 with FS2-based resource management

New
New
Closed
2009-02-10
2003-05-31
2013-10-31

History

#1 - 2013-10-11 09:48 - skyjake

- Tracker changed from Bug to Feature

#2 - 2013-10-11 09:56 - skyjake

- Description updated

#3 - 2015-01-13 13:53 - skyjake

- Description updated

#4 - 2015-01-13 13:53 - skyjake

- Description updated

#5 - 2015-01-13 13:54 - skyjake

- Description updated

#6 - 2015-12-22 13:14 - skyjake
- Related to deleted (Feature #1233: Surface decorations using 3D models)

#7 - 2015-12-22 13:20 - skyjake

- Related to Bug #908: Detail texture maximum distance ignored added

#8 - 2015-12-22 13:21 - skyjake
- Related to Bug #606: Shiny texture coordinate issues added

#9 - 2016-03-27 08:41 - skyjake

- Target version set to Rendering

#10 - 2016-07-06 00:02 - skyjake

- Status changed from In Progress to Progressed

#11 - 2017-01-22 08:51 - skyjake
- Related to Feature #1168: Real decals: bulletholes, blastmarks, etc. added

#12 - 2018-10-27 15:01 - skyjake

- Subject changed from Next-gen renderer to Next-gen renderer (codename "Gloom")

- Category set to Redesign
- Assignee changed from Deng Team to skyjake

- % Done changed from 24 to 30

#13 - 2018-10-27 16:10 - skyjake

- Target version changed from Rendering to 3.0

#14 - 2019-11-29 16:34 - skyjake

- Related to Feature #1647: Replace FS1 with FS2-based resource management added
